#include <iostream>
#include <vector>

#include "gene.h"
#include "chromosome.h"

using namespace std;
using namespace genetic;

int main() {
    typedef Gene<int> _Gene;
    typedef Chromosome<_Gene> _Chromosome;

    const unsigned int chromosomeSize = 20;

    std::vector<_Gene> data;

    for (unsigned int i = 0; i < chromosomeSize; i++) {
        data.push_back(_Gene(i));
    }

    _Chromosome chromosome(data);

    if (chromosome.size() != chromosomeSize) {
        cout << "Chromosome contained incorrect size after creation\n";
        return 1;
    }

    for (unsigned int i = 0; i < chromosome.size(); i++) {
        if (chromosome[i].get() != i) {
            cout << "Chromosome contained bad data after creation\n";
            return 1;
        }
    }

    cout << "Chromosome is created correctly\n";
    return 0;
}

