#include <iostream>
#include <vector>

#include "gene.h"
#include "chromosome.h"
#include "generation.h"

using namespace std;
using namespace genetic;

int main() {
    typedef Gene<int> _Gene;
    typedef Chromosome<_Gene> _Chromosome;
    typedef Generation<_Chromosome> _Generation;

    const unsigned int chromosomeSize = 20;
    const unsigned int generationSize = 100;

    std::vector<_Gene> chromosomeData;
    std::vector<_Chromosome> generationData;

    for (unsigned int i = 0; i < generationSize; i++) {
        for (unsigned int j = 0; j < chromosomeSize; j++) {
            chromosomeData.push_back(_Gene(i*j));
        }
        generationData.push_back(_Chromosome(chromosomeData));
    }

    _Generation generation(generationData);

    _Generation generation2 = generation;

    if (generation2.size() != generation.size()) {
        cout << "Generation contained incorrect size after copying\n";
        return 1;
    }

    for (unsigned int i = 0; i < generation.size(); i++) {
        for (unsigned int j = 0; j < generation[i].size(); j++) {
            if (generation[i][j].get() != generationData[i][j].get()) {
                cout << "Generation contained bad data after copying\n";
                return 1;
            }
        }
    }

    cout << "Generation is created correctly\n";
    return 0;
}

